using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Generals;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IGeneralLedgerRepository
    {
        Task<BaseResult> Add(GeneralLedgerElastic GeneralLedger);
        Task<BaseResult> AddManyAsync(IEnumerable<GeneralLedgerElastic> GeneralLedgers);
        Task<SmartTableResult<GeneralLedgerElastic>> Search(BoolQueryDescriptor<GeneralLedgerElastic> query);

    }
    public class GeneralLedgerRepository : IGeneralLedgerRepository
    {
        private readonly ElasticIndex<GeneralLedgerElastic> _dbContext;

        public GeneralLedgerRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<GeneralLedgerElastic>(settings.Value.ClusterUrl, "inventorygeneralledger");
        }


        public async Task<SmartTableResult<GeneralLedgerElastic>> Search(BoolQueryDescriptor<GeneralLedgerElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(GeneralLedgerElastic GeneralLedger)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(GeneralLedger);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<GeneralLedgerElastic> GeneralLedgers)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(GeneralLedgers);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
